#!/bin/bash 

if [ $# -lt 1 ] 
then
   echo "usage: "$0" <objdump's output> <directory path>"
   exit 1
fi

if [[ -z ${DB} ]]
then
    echo "Missing assignment"
    echo "    DB environment variable not set"
    exit 1
fi

if [[ -z ${OBJDUMP} ]]
then
    echo "Missing assignment"
    echo "    OBJDUMP environment variable not set"
    exit 1
fi

if [[ -z ${LCTBIN} ]]
then
    echo "Missing assignment"
    echo "    LCTBIN environment variable not set"
    exit 1
fi

SIZETABLE=${DB}/sizes.tbl

grep " size" $1 | grep id | grep -v bitsize | grep -v "union " \
     | grep "^[[:blank:]]*struct" | sed 's/;//' >  ${DB}/T_structure.txt
grep typedef $1 | grep " id " | sed 's/;//' >  ${DB}/T_typedef.txt
awk -f ${LCTBIN}/awktypedefsizes.awk ${DB}/T_typedef.txt
awk -f ${LCTBIN}/awkstructsizes.awk  ${DB}/T_structure.txt
awk -f ${LCTBIN}/anonsizes.awk $1
awk -f ${LCTBIN}/anonsizes2.awk $1
$2/getsize $SIZETABLE 
grep "^typedef" ${OBJDUMP}  | grep -v "/\* [[:print:]]* \*/" | awk -f ${LCTBIN}/typedefs.awk
sort -u ${SIZETABLE} > $SIZETABLE.tmp
#rm T_typedef.txt T_structure.txt
mv $SIZETABLE.tmp $SIZETABLE 
