#!/bin/bash

if [[ -z $DB ]]
then
    echo "Missing assignment"
    echo "    DB environment variable not set"
    exit 1
fi

if [[ -z $EXEFILE ]]
then
    echo "Missing assignment"
    echo "    EXEFILE environment variable not set"
    exit 1
fi

if [[ -z $LCTBIN ]]
then
    echo "Missing assignment"
    echo "    LCTBIN environment variable not set"
    exit 1
fi

if [[ -z $OBJDUMP ]]
then
    echo "Missing assignment"
    echo "    OBJDUMP environment variable not set"
    exit 1
fi


GetType()
{
echo "$1" |  
    awk  ' { 
	z=$0
	#print "-->" z
	sub(" *[(].*$","()",z)
	sub(" *[[].*$","",z)
	sub(";$","",z)
	sub("^[ 	]*","",z)
	sub("[ 	]*$","",z)
	sub("^extern *","",z)
	split( z, a, ",")
	split( a[1], b, ";")
	#sub("^.*>  *","",z)
	#sub("^[&*]*[ \t]*","",z)
	#sub("^.*>  *","",z)
	sub( "[ \t]*[[:alnum:]]*[-_]*[[:alnum:]]*[-_]*[[:alnum:]]*$","", b[1])
	print b[1]
    }'
}

OldGetType()
{
echo "GetType .. 1 = $1"
[ $LCTSTAT ] && echo ENTER GetType `date +"%j %H %M %S %N"` >> ${LCTSTAT}.nano
   ARR=0
   echo "$1" | awk '{\
   if (($0 ~ /[(]/) && ($0 !~ /[(][^)]*[)]/)) {
      sub("$", ")", $0);
   }
   if ($0 !~ /;/) {
      sub("$", ";", $0);
   }
   sub("^[[:blank:]]*extern[[:blank:]]*","",$0)
   while ($0 ~ /[(][^)]*[)]/ ) {
     FUNCALL += sub("[(][^)]*[)]", "", $0);
   }
   while ($0 ~ /[[][^]]*[]]/) {
     sub("[[][^]]*[]]", "", $0);
     ARR++;
   }
   ARR=ARR+gsub("[*]","",$0)
   sub("[[:blank:]]*;",";",$0)
   sub("[[:blank:]]*[^[:blank:]]*;","",$0)
   if (ARR && ($0 !~ /[[:blank:]]$/)) {
    sub("$", " ", $0);
   }
   while(ARR > 0)
   {
    sub("$","*",$0)
    ARR--
   }
   print $0 }'
[ $LCTSTAT ] && echo EXIT GetType `date +"%j %H %M %S %N"` >> ${LCTSTAT}.nano
}

GetSize()
{
[ $LCTSTAT ] && echo ENTER GetSize `date +"%j %H %M %S %N"` >> ${LCTSTAT}.nano
  awk -F "	" -v typ="$1" '
	BEGIN {
	    split(typ, a, "*");
	    strpdtype=a[1];
	    sub("^[ 	]*", "", strpdtype)
	    sub("[ 	]*$", "", strpdtype)
	    found=0
	}
	$1 == strpdtype { print $2; found=1; exit; }
	END {if (!found) print "-1"; }
  ' $SIZETABLE
#  STRPDTYPE=`echo "$1" | awk '{ split($0,a,"*"); print a[1] }'`
#  cat $SIZETABLE | while read line
#  do
#    CURRTYPE=`echo "$line" | awk -F "\t" '{print $1}'`
#    if [ "$CURRTYPE" == "$STRPDTYPE" ]
#    then 
#     CURRSIZE=`echo "$line" | awk -F "\t" '{print $2}'`
#     echo $CURRSIZE
#     return
#    fi
#  done 
[ $LCTSTAT ] && echo EXIT GetSize `date +"%j %H %M %S %N"` >> ${LCTSTAT}.nano
}

StripOthers()
{
export VAL=$2
echo $1 |  awk ' { 

	split( $0, a, ",");
	for ( var in a )
	{
		z = a[var]
		sub(" *[(].*$","()",z)
		sub(" *[[].*$","",z)
		sub(";$","",z)
		sub("^[ 	]*","",z)
		sub("[ 	]*$","",z)
		sub("^extern *","",z)
		sub("^static *","",z)
		sub("^const *","",z)
		sub("^short int *","int ",z)
		sub("^long int *","int ",z)
		sub("^unsigned *","",z)
		sub("^long unsigned *","",z)
		sub("^struct *","",z)
		sub("^union *","",z)
		sub("^enum *","",z)
		sub("^[^ ]*  *","",z)
		sub("^.*>  *","",z)
		sub("^[&*]*[ \t]*","",z)
		sub("^.*>  *","",z)

		gsub( " ", "", z)
		gsub( ";", "", z)
		if( z == ENVIRON["VAL"])
			print z 
	}
    }'

}

GetName()
{
[ $LCTSTAT ] && echo ENTER GetName `date +"%j %H %M %S %N"` >> ${LCTSTAT}.nano
   echo "$1" | awk '{\
	 z = $0
	 sub(" *[(].*$","()",z)
	 sub(" *[[].*$","",z)
	 sub(";$","",z)
	 sub("^[ 	]*","",z)
	 sub("[ 	]*$","",z)
	 sub("^extern *","",z)
	 sub("^static *","",z)
	 sub("^const *","",z)
	 sub("^short int *","int ",z)
	 sub("^long int *","int ",z)
	 sub("^unsigned *","",z)
	 sub("^long unsigned *","",z)
	 sub("^struct *","",z)
	 sub("^union *","",z)
	 sub("^enum *","",z)
	 sub("^[^ ]*  *","",z)
	 sub("^.*>  *","",z)
	 sub("^[&*]*[ \t]*","",z)
	 sub("^.*>  *","",z)
	 print z
   }'
[ $LCTSTAT ] && echo EXIT GetName `date +"%j %H %M %S %N"` >> ${LCTSTAT}.nano
}

SearchTemps()
{
[ $LCTSTAT ] && echo ENTER SearchTemps `date +"%j %H %M %S %N"` >> ${LCTSTAT}.nano
  grep -n -H "^[[:blank:]]*extern[[:print:]]*$1" $j > /dev/null 2>&1
  grep -n -H "^[[:blank:]]*extern[[:print:]]*$1" $j > /dev/null 2>&1
  sts=$?
  TYPE=$3
  if [[ $sts == 0 ]]
  then
     INC=1
#     BCOUNT=`grep "^[[:blank:]]*extern[[:print:]]*$1" $2 | wc -l`
     BCOUNT=`egrep "^[[:blank:]]*extern[^(]*[^a-zA-Z0-0_(]$1[^a-zA-Z0-0_(]|^[[:blank:]]*extern[^(]*[^a-zA-Z0-0_(]$1\$" $2 | wc -l`
     while [ $INC -le $BCOUNT ]
     do
#            FLINE=`grep -n -H "^[[:blank:]]*extern[[:print:]]*$1" $2 | head -$INC | tail -1`
            FLINE=`egrep -n -H "^[[:blank:]]*extern[^(]*[^a-zA-Z0-0_(]$1[^a-zA-Z0-0_(]|^[[:blank:]]*extern[^(]*[^a-zA-Z0-0_(]$1\$" $2 | head -$INC | tail -1`
            TMPLINE=`echo "$FLINE" | awk -F ":" '{print $2}'`
            SOURCELINE=`echo "$FLINE" | awk -F ":" '{print $NF}'`
            #EXTYPE=`GetType "$SOURCELINE"`
            #EXSIZE=`GetSize "$EXTYPE"`
            #EXNAME=`GetName "$SOURCELINE"`

	    REALVAL=`StripOthers "$SOURCELINE" $1`
            EXTYPE=`GetType "$SOURCELINE"`
            EXSIZE=`GetSize "$EXTYPE"`
            EXNAME=`GetName "$REALVAL"`
if [ "${EXNAME}" != "$1" ] #CRE
then #CRE
    echo "WARN:  [ <${EXNAME}> != <$1> ]"
    echo "CRE - 1<${1}> 2<${2}> 3<$3> 4<$4>" #CRE
    echo "EXNAME=\`GetName \"$SOURCELINE\"\`" #CRE
fi #CRE
#if [ "${EXNAME}" = "isSecureFileError" ] #CRE
#then #CRE
    #echo "CRE - 2<${1}> 2<${2}> 3<$3> 4<$4>" #CRE
    #echo "EXNAME=\`GetName \"$SOURCELINE\"\` = $EXNAME" #CRE
    #echo "EXTYPE=\`GetType \"$SOURCELINE\"\` = $EXTYPE" #CRE
    #echo "EXSIZE=\`GetSize \"$EXTYPE\"\` = $EXSIZE" #CRE
#fi #CRE
            if [[ "${EXTYPE}" != "$3" || "${EXSIZE}" != "$4" ]]
             then
	       DN=`dirname $2`
               SOURCEFILE=`head -$TMPLINE $2 | nl | sort -rn |
		   grep '# [0-9]* "[[:print:]]*"' | head -1 |
		   awk -v "dn=${DN}" '{
			if (NR > 1) 
			    next
		   	gsub("\"","",$4);
			if ($4 !~ "^[/]")
				print dn "/" $4
			else
			    print $4
		    }'`
               SOURCELINEOUT=`head -$TMPLINE $2 | nl | sort -rn | grep '# [0-9]* "[[:print:]]*"' | head -1 | awk '{print $3}'`
               if [ "${EXSIZE}" != "$4" ]
               then
                  echo -e "${SOURCEFILE}\t${SOURCELINEOUT}\tE40001\tGlobal Variable \"$EXNAME\" size mismatch ${EXSIZE} (Defined in \"$DEFILENAME\" as \"$4\")" >> "${DB}/tSourceMsgs.tbl"
               else 
                  if [ "${EXTYPE}" != "$3" ]
                  then
                     echo -e "${SOURCEFILE}\t${SOURCELINEOUT}\tE40002\tGlobal Variable \"$EXNAME\" type mismatch \"${EXTYPE}\" (Defined in \"$DEFILENAME\" as \"$3\")" >> "${DB}/tSourceMsgs.tbl"
                  fi
               fi
             else
               INC=`expr $INC + 1`
               continue
            fi
       INC=`expr $INC + 1`
     done
  fi
[ $LCTSTAT ] && echo EXIT SearchTemps `date +"%j %H %M %S %N"` >> ${LCTSTAT}.nano
}

SearchSource()
{
  grep -n -H "^[[:blank:]]*extern[[:print:]]*$1" $j >/dev/null 2>&1
}

SOURCELIST=${DB}/sourcelist.list
GLOBALDEFS=${DB}/tGlobalVarDef.tbl
SIZETABLE=${DB}/sizes.tbl

typeset -i -x TMP
TMP=0

if [ ! -f ${SOURCELIST} ]
then
   awk -f ${LCTBIN}/filelist.awk ${OBJDUMP} | sed 's/^[[:blank:]]*//' | sort -u > ${SOURCELIST}
   for i in `cat ${SOURCELIST}`
   do
      if [ -f `echo $i | awk '{sub("[.][a-z,A-Z,0-9,_,+]*$",".i",$0);print $0}'` ]
      then
         echo $i |  awk '{sub("[.][[:print:]]*$",".i",$0); print $0}' >> ${SOURCELIST}.tmp
      else
         if [ -f `echo $i | awk '{sub("[.][a-z,A-Z,0-9,_,+]*$",".ii",$0);print $0}'` ]
         then
           echo $i |  awk '{sub("[.][[:print:]]*$",".ii",$0); print $0}' >> ${SOURCELIST}.tmp
         fi
      fi
   done

   if [ -f ${SOURCELIST}.tmp ]
   then
     mv ${SOURCELIST}.tmp  ${SOURCELIST}
     TMP=1
   fi
else
   grep "\.i*$" ${SOURCELIST} > /dev/null 2>&1
   sts=$?
   if [ $sts -eq 0 ]
   then
     TMP=1
   fi
fi

typeset -i -x INC
typeset -i -x BCOUNT
typeset -x DEFILENAME

for i in `awk -F "\t" '{ print $2}' ${GLOBALDEFS}`
do
   export i
   TYPE=`awk -F "\t" '{ if($2 == ENVIRON["i"]){print $3}}' ${GLOBALDEFS} | head -1`
   SIZE=`awk -F "\t" '{ if($2 == ENVIRON["i"]){print $5}}' ${GLOBALDEFS} | head -1`
   DEFILENAME=`awk -F "\t" '{ if($2 == ENVIRON["i"]){print $8}}' ${GLOBALDEFS} | head -1`

   for j in `cat ${SOURCELIST}`
   do
     if [[ $TMP > 0 ]]
     then
        SearchTemps $i $j "$TYPE" $SIZE
     else
        SearchSource $i $j "$TYPE" $SIZE
     fi
   done
done
