#!/bin/bash 
#
# Linux Compatablity Tool Summary Display script
#

if [[ -z $DB ]]
then
    echo "Missing assignment"
    echo "    DB environment variable not set"
    exit 1
fi

numFiles=`cat ${DB}/tFunctionDef.tbl | awk -F"	" '{print $6}' | sort -u | wc -l | sed 's/[ 	]*//'`
numWarns=`sort -u  ${DB}/tSourceMsgs.tbl | awk -F"	" '{print $3}' | grep -c W`
numErrs=`sort -u  ${DB}/tSourceMsgs.tbl | awk -F"	" '{print $3}' | grep -c E`

# Clear out line being used for summary data ...
echo "                                                             "
echo "	Found ${numWarns} warnings and"
echo "	      ${numErrs} errors in"
echo "	      ${numFiles} files"

exit 0
