###################################
# (C) Copyright International Business Machines (IBM), 2001, 2002, 2005
# Useable and distributable only with IBM permission and under IBM terms and
# conditions. It may not be copied or further distributed unless authorized in
# writing by IBM.
###################################
# use strict;
# use diagnostics -verbose;

sub parameter_scan() {

#if we are looking at the first or last parameter, we don't want the ( or ) in the variable.
    my $clean_params = $portManager::params;

    #remove the ( and ) and any spaces
    $clean_params =~ s/\(//g;
    $clean_params =~ s/\)//g;
    $clean_params =~ s/\s*//g;

    my @breakup = split /,/, $clean_params;

    #find where in the array we are going to look for a possible problem
    my $index =
      $portManager::param_check{$portManager::fn_name}->param_slot - 1;

#  if($portManager::param_check{$portManager::fn_name}->alter eq $breakup[$index])
    if ( $portManager::param_check{$portManager::fn_name}->alter =~
        m/$breakup[$index]/ )
    {

#the parameter in question is set at the known problematic value. up level to difficult
        $portManager::tstring =~
s/$portManager::pattern/$portManager::DIFFICULTFLAGFRONT$portManager::fn_name$portManager::DIFFICULTFLAGBACK$portManager::cur_func_doc$portManager::params\n/;
    }
    elsif ( $portManager::param_check{$portManager::fn_name}->allow eq
        $breakup[$index] )
    {

#the parameter value in question is not a problem value
#if the function is defined as an easy or moderate diff level, we still need to flag it.
#if its null in the port_funcs.in file, we don't do anything to it
        if ( $portManager::fcs{$portManager::fn_name}->diff_level eq "easy" ) {
            $portManager::tstring =~
s/$portManager::pattern/$portManager::EASYFLAGFRONT$portManager::fn_name$portManager::EASYFLAGBACK$portManager::cur_func_doc$portManager::params\n/;
        }
        elsif (
            $portManager::fcs{$portManager::fn_name}->diff_level eq "moderate" )
        {
            $portManager::tstring =~
s/$portManager::pattern/$portManager::MEDIUMFLAGFRONT$portManager::fn_name$portManager::MEDIUMFLAGBACK$portManager::cur_func_doc$portManager::params\n/;
        }
        elsif ( $portManager::fcs{$portManager::fn_name}->diff_level eq
            "difficult" )
        {
            $portManager::tstring =~
s/$portManager::pattern/$portManager::DIFFICULTFLAGFRONT$portManager::fn_name$portManager::DIFFICULTFLAGBACK$portManager::cur_func_doc$portManager::params\n/;
        }
    }
    else {

        #cannot determine what the parameter in question is truly set at.
        $portManager::tstring =~
s/$portManager::pattern/$portManager::UNKNOWNFLAGFRONT$portManager::fn_name$portManager::UNKNOWNFLAGBACK$portManager::cur_func_doc$portManager::params\n/;
        $portManager::unknown_count++;    #increment the unknown count
    }

}    #end parameter_scan()

1;
