###################################
# (C) Copyright International Business Machines (IBM), 2001, 2002, 2005
# Useable and distributable only with IBM permission and under IBM terms and
# conditions. It may not be copied or further distributed unless authorized in
# writing by IBM.
###################################

package structs;
use Class::Struct;

# use strict;
# use diagnostics -verbose;

struct fcn_info => {
    solaris_fcn => '$',
    linux_fcn  => '$',
    category   => '$',
    action     => '$',
    doc_file   => '$',
    diff_level => '$'
};

struct param_info => {
    param_slot  => '$',
    param_list1 => '$',
    list1_level => '$',
    param_list2 => '$',
    list2_level => '$',

};

# Edit flags - used to mark functions
our $DIFFICULTFLAGFRONT = "\!~";
our $DIFFICULTFLAGBACK  = "\~!";
our $MEDIUMFLAGFRONT    = "\!&";
our $MEDIUMFLAGBACK     = "\&!";
our $EASYFLAGFRONT      = "\!%";
our $EASYFLAGBACK       = "\%!";
our $UNKNOWNFLAGFRONT   = "\!@";
our $UNKNOWNFLAGBACK    = "\@!";

#
# message_parm_struct is the message parameter list, used to return message
#                     information from the backend to the GUI
# msg_parm_num_messages is the number of messages returned from the backend
# msg_parm_message_info_array_struct is an array, where the values are grouped by 3:
# msg_info_array_hashkey is the message hash key (what msg to issue)
# msg_info_array_insert1 is the first msg insert
# msg_info_array_insert2 is the second msg insert
#
struct message_parm_struct => {
    msg_parm_num_messages              => '$',
    msg_parm_message_info_array_struct => '@'
};

struct message_info_array_struct => {
    msg_info_array_hashkey => '$',
    msg_info_array_insert1 => '$',
    msg_info_array_insert2 => '$'
};

1;
